%global commit a4d820dd69b37fb8daee275d20eb162054453414
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           restbed
Version:        4.8
Release:        3%{?dist}
Summary:        RESTful functionality for C++11 applications

License:        AGPLv3+
URL:            https://github.com/Corvusoft/restbed
Source0:        https://github.com/Corvusoft/restbed/archive/%{version}.tar.gz
Source1:        https://github.com/chriskohlhoff/asio/archive/%{commit}.tar.gz#/asio-%{shortcommit}.tar.gz
Patch0:         get_authority_fix.patch
Patch1:         ipc_support.patch
Patch2:         disable_static_build.patch
Patch3:         support_for_catch2_v3.patch

BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  catch-devel
BuildRequires:  openssl-devel
Requires:       openssl

%description
Restbed is a comprehensive and consistent programming model for building
applications that require seamless and secure communication over HTTP, with the
ability to model a range of business processes, designed to target mobile,
tablet, desktop and embedded production environments.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
%setup -q
%setup -q -D -T -a1
%patch 0 -p1
%patch 1 -p1
%patch 2 -p1
%patch 3 -p1
rmdir dependency/asio && ln -s ../asio-%{commit} dependency/asio

%build
%cmake -DBUILD_TESTS=ON -DBUILD_IPC=ON -DBUILD_SSL=ON -DCMAKE_INSTALL_LIBDIR=%{_lib}
%cmake_build

%install
%cmake_install

%check
cd %__cmake_builddir
ctest

%files
%license LICENSE
%doc README.md
%{_libdir}/librestbed.so.*

%files devel
%{_includedir}/restbed
%{_includedir}/corvusoft/
%{_libdir}/librestbed.so
